from typing import AsyncIterable

from v6d3music.core.default_effects import *
from v6d3music.core.ystate import *
from v6d3music.core.ytaudio import *
from v6d3music.core.caching import Caching
from v6d3music.processing.pool import *
from v6d3music.utils.argctx import *

from v6d2ctx.context import Context


async def yt_audios(caching: Caching, defaulteffects: DefaultEffects, ctx: Context, args: list[str]) -> AsyncIterable[YTAudio]:
    assert ctx.guild is not None
    argctx = ArgCtx(defaulteffects.get(ctx.guild.id), args)
    async with Pool(5) as pool:
        async for audio in YState(caching, pool, ctx, argctx.sources).iterate():
            yield audio
